#!/usr/bin/perl
##########################################################################
# NEWS Script fuer Unix V1.0
# Bugs oder Verbesserungen bitte an ralf@viellieber.de
# Das Programm findet die neuesten Dateien mit den Endungen : 
# 'htm', 'html' ,'shtm', 'shtml'
# Man kann Verzeichnissen und einzelne HTML-Dateien von der Anzeige 
# ausschlieen. Einfach Kommentar <!--keine News--> in die erste Zeile 
# der Datei kopieren.
#
# WICHTIG: Ist eine Tilde '~' im Pfadnamen (bzw.html-Namen) 
#          luft das Programm nicht richtig. Muss man dann selbst ersetzen
#
# Dieses Script eignet sich nur fuer mittelgroe Seiten, weil es schon ein wenig
# rechnet -> Providerproblem ;-)
#
# Es muessen nur die Variablen am Anfang angepasst werden (+ evtl. die 1. Zeile)
##########################################################################
# hier nix aendern
$| = 1 ;
use File::Find ;
use strict ;
##########################################################################
# ab hier aendern

#Beginn des Suchpfades auf der Platte
 my $search_dir = "/var/web/viellieber.de/wwwdata" ;

#WWW-Pfad Startdatei
 my $home = "http://www.viellieber.de/index.html" ;

#Beginn des WWW-Pfades incl. Host der Suche
 my $www_host = "http://www.viellieber.de" ;

#Ausgeschlossene Verzeichnisse
 my @expaths = ('/logdats/', '/witzdat/', '/wwwboards/', '/bins/') ;

# So alt duerfen die Webseiten hoechstens sein (in Tagen)
 my $so_alt = 30;

# Meldung wemm keine neuen Seiten gefunden
 my $keineSeiten = "Ralf war faul - keine neuen Seiten!!";

# Wenn Seite keinen Titel hat
 my $kein_Titel = "Seite hat keinen Titel" ;	

# Titel der Ausgabeseite
 my $AusgabeSeite = "Das ist bei www.viellieber.de die letzten " . $so_alt . " Tage passiert.";

# Farbe der Links (besucht und drueber)
 my $LinkColor = "steelblue";

# <body background=""> der Ausgabeseite
 my $back="$www_host/images/back.jpg";

# Text fuer Zurueck-Link
 my $zurueck = "zur&uuml;ck zur Startseite";

# Schriftart, mehrere durch Komma trennen 1. hat hoechste Prioritaet
 my $font="Verdana, Arial, Helvetica";

############ Anpassungen bis hier #######################################


#Anzahl der Newsseiten initialisieren
 my $i=0;

 my @treffer ;
 my $datum ;


##############################################################################
# Hauptprogramm
##############################################################################

find(\&get_dir_tree, $search_dir) ;

&kopf ;

if ($i==0) {
	print "<table border=0 width=100%><tr><td><br><br><blockquote><font face=\"$font\" size=-1>";
	print "<b>$keineSeiten</b></font></blockquote></td></tr>" ;

} else {
 	print "<table border=0 cellpadding=2>\n\n";
	&ausgabe; 
} 
&fuss;
exit;


################################################################################
# Unterprogramme
################################################################################

sub get_dir_tree {

my $no=0 ;
my $expath="" ;
my $akt_file = $File::Find::name ;

# Ausschluss aller nicht erlaubten Verzeichnisse
foreach $expath (@expaths) {
	$no=1 if ($akt_file =~ /^$search_dir$expath/i) ;
}
&datum(-M $akt_file) ;	
if ($datum ne "") {
  &search_the_file($akt_file) if ($akt_file =~ /\..?htm?/i && $no==0) ;
}
}


################################################################################
# ermittelt zu jeder Datei: Datum~Link mit Beschreibung~Metatagbeschreibung
# schreibt in Trefferarray
################################################################################
sub search_the_file {

my $search_file = $_[0] ;
my @lines ; 
my $line ; 
my $www_path ;
my $beschr ;
my $title ;

# muss fuer Datumermittlung das File offen sein?
open (IN, "<$search_file") || return;
@lines = <IN> ;
&datum(-M $search_file) ;	
close(IN) ;

$line = join(' ',@lines);    

if ($line !~ /<!--keine News-->/i) {
	if ($line =~ /<title>(.*)<\/title>/i) {
		$title = "$1";
	} else {
		$title = $kein_Titel;
	} 
	# Link mit Beschreibung erzeugen
	$www_path = $search_file ;
	$www_path =~ s/$search_dir(.*)/<a href=\"$www_host$1\">$title<\/a>/i ;

	# wenn im Metatag eine Beschreibung ist -> anzeigen
	if ($line =~ /<meta name="description" content="(.*?)\">/i) {
		$beschr=$1 ;
	} else {
		$beschr="" ;
	}
	$treffer[$i] = "$datum~$www_path~$beschr" ;
	$i++ ;
}

return 1;
}


################################################################################

sub kopf {

print "Content-Type: text/html\n\n";

print <<"AUSGABE" ;

<HTML>
<HEAD>

<TITLE>$AusgabeSeite</TITLE>

<style type="text/css">
<!--
   A:link {text-decoration: none; color: $LinkColor}
   A:visited {text-decoration: none; color: $LinkColor}
   A:hover {color: $LinkColor}
-->
</style>

</head>

<body background="$back">
 
<h1>$AusgabeSeite</h1>
<br>

AUSGABE

}


######################################################################
# Copyright bitte drin lassen
sub fuss {

print <<"AUSGABE" ;

</table>
<a href="$home">$zurueck</a>
<br>
<p align=left><br>
<a href="http://www.viellieber.de">&copy; kostenloses Perlscript von Ralf Viellieber</a>
</p>
<br>
&nbsp;

</center>

</body>
</html>

AUSGABE

}


######################################################################
# Ausgabe der Ergebnisse
######################################################################

sub ausgabe {

my @dat ;
my @suchbeg ;
my $key ;
my $suchalt ;
my $sb ;


# Sortieren nach Datum
# In Treffer stehen die Seiten in einer Zeile mit Infos durch ~ getrennt
foreach $key (sort {$b cmp $a} @treffer) {
	@suchbeg = split(/~/, $key);

	@dat = split(/:/ , $suchbeg[0]) ;

	print <<"AUSGABE" ;

	<tr>
		<td valign=top>
		<font face=\"$font\" color=black>[ $dat[2].$dat[1].$dat[0] ]</font>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		</td>
		
		<td>
		<font face=\"$font\">$suchbeg[1]</font><br>
		<font face=\"$font\" size=-1>$suchbeg[2]
		</td>
	</tr>
AUSGABE
}

}


######################################################################
# Start laden
######################################################################
# Wichtig ist Leerzeile danach
sub gotostart {
print "Location: $home\n\n" ;
}


############################################################################
# Liefert Dateidatum als String zurueck "" wenn zu alt
############################################################################

sub datum {

my $time ;
my $sec ;
my $min ;
my $hour ;
my $mday ;
my $mon ;
my $year ;
my $wday ;
my $yday ;
my $isdst ;
my $zeitdiff ;

$time = time;

if (($_[0]*3600*24) < $so_alt*3600*24)
{
  # Datei ist neu also aufnehmen
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time-($_[0]*3600*24)) ;
		
  $year+=1900 ;
  $mon++ ;
  $mon = "0$mon" if ($mon < 10) ;
  $mday = "0$mday" if ($mday < 10) ;
	
  # durch : getrennt s. Funktion ausgabe
  $datum="$year:$mon:$mday" ;
}
else {
  # Datei ist schon aelter als Vorgabe
  $datum="" ;
}

}
